<script setup lang="ts">
import { nextTick, ref } from 'vue'
import type { Member } from '@/types/Member'
import { useMembersStore } from '@/stores/member'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Tel',
    key: 'tel'
  },
  {
    title: 'Point',
    key: 'point'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const membersStore = useMembersStore()

let editedIndex = -1
const editedMembers = ref<Member>(JSON.parse(JSON.stringify(membersStore.defaultMembers)))
const members = ref<Member[]>([])
members.value = membersStore.members
const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)
let lastestId = 1
let latestId = 1
members.value.forEach((member) => {
  if (member.id > lastestId) {
    latestId = member.id
  }
})
lastestId = latestId + 1

function editItem(item: Member) {
  editedIndex = members.value.indexOf(item)
  editedMembers.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Member) {
  editedIndex = members.value.indexOf(item)
  editedMembers.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  members.value.splice(editedIndex, 1)
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedMembers.value = Object.assign({}, membersStore.defaultMembers)
  })
  editedIndex = -1
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedMembers.value = Object.assign({}, membersStore.defaultMembers)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(members.value[editedIndex], editedMembers.value)
  } else {
    editedMembers.value.id = lastestId++
    members.value.push(editedMembers.value)
  }
  closeDialog()
}
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="members">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #212121; color: white">
          <v-toolbar-title>Member</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="600">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" style="background-color: #c7a17a; color: white">
                New Member
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedMembers.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Name"
                          placeholder="Enter Member Name"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="8">
                        <v-text-field
                          v-model="editedMembers.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          clearable
                          label="Tel"
                          placeholder="Enter Member Tel"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedMembers.point"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Fill Data']"
                          class="mb-2"
                          clearable
                          label="Point"
                          placeholder="Enter Member Point"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*Please Fill Data</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" v-model="dialogDelete" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped>
.grey-background {
  background-color: #e0e0e0;
}
</style>
